#include <linux/autoconf.h>

#ifdef CONFIG_UMSDOS_UPON_DMSDOS

#include <linux/dmsdos_fs.h>

/* define all msdos calls to dmsdos calls */
/* msdos_dir_read unchanged (returns only an error) */
#define msdos_readdir dmsdos_readdir
#define msdos_file_read dmsdos_file_read
#define msdos_file_write dmsdos_file_write
#define msdos_create dmsdos_create
#define msdos_lookup dmsdos_lookup
#define msdos_read_super dmsdos_read_super
#define msdos_rename dmsdos_rename
#define msdos_unlink dmsdos_unlink
#define msdos_rmdir dmsdos_rmdir
#define msdos_mkdir dmsdos_mkdir
#define msdos_unlink_umsdos dmsdos_unlink_umsdos
#define msdos_truncate dmsdos_truncate
/* msdos_bmap unchanged (unsupported in compressed partitions) */
/* msdos_smap unchanged (unsupported in compressed partitions) */
#define msdos_mmap dmsdos_mmap
#define msdos_put_inode dmsdos_put_inode
#define msdos_put_super dmsdos_put_super
#define msdos_statfs dmsdos_statfs
#define msdos_read_inode dmsdos_read_inode
#define msdos_write_inode dmsdos_write_inode
#define msdos_notify_change dmsdos_notify_change

/* kernel 1.3.8x has some name changed */
#ifdef __FOR_KERNEL_1_3_8x
#define fat_readdir dmsdos_readdir
#define fat_file_read dmsdos_file_read
#define fat_file_write dmsdos_file_write
#define fat_create dmsdos_create
#define fat_lookup dmsdos_lookup
#define fat_read_super dmsdos_read_super
#define fat_rename dmsdos_rename
#define fat_unlink dmsdos_unlink
#define fat_rmdir dmsdos_rmdir
#define fat_mkdir dmsdos_mkdir
#define fat_unlink_umsdos dmsdos_unlink_umsdos
#define fat_truncate dmsdos_truncate
/* fat_bmap unchanged (unsupported in compressed partitions) */
/* fat_smap unchanged (unsupported in compressed partitions) */
#define fat_mmap dmsdos_mmap
#define fat_put_inode dmsdos_put_inode
#define fat_put_super dmsdos_put_super
#define fat_statfs dmsdos_statfs
#define fat_read_inode dmsdos_read_inode
#define fat_write_inode dmsdos_write_inode
#define fat_notify_change dmsdos_notify_change
#endif

#endif